// Kalkulator.java

import java.awt.*;
import java.awt.event.*;

public class Kalkulator extends Frame {
  
  private long x, y;    // Registri kalkulatora.
  private Label[] reg = new Label [2];
  private final int X = 0, Y = 1;
  private boolean noviBroj = true;
  private int osnova=10;
  private Button[] cifre = new Button [16];
  
  public Kalkulator () {
    super ("Kalkulator");
    setBounds (250, 50, 270, 234);
    setResizable (false);
    addWindowListener (new ProzorDogadjaj());
    setLayout(new BorderLayout());
    
    /* Dugmad sa ciframa */ {
      Panel ploca = new Panel();
      ploca.setLayout (new GridLayout (4, 4));
      add (ploca,  BorderLayout.CENTER);
      CifraAkcija osmatrac = new CifraAkcija ();
      for (int i=0; i<16; i++) {
        ploca.add (cifre[i]=new Button (Integer.toString(i,16)));
        cifre[i].addActionListener (osmatrac);
        cifre[i].setEnabled (i<osnova);
      }
    }
    
    /* Radio dugmad sa osnovama brojevnih sistema */ {
      String[] ozn = {"2", "8", "10", "16"};
      Panel ploca = new Panel();
      add (ploca,  BorderLayout.WEST);
      ploca.setLayout (new GridLayout (ozn.length,1));
      ploca.setBackground (Color.yellow);
      CheckboxGroup grupa = new CheckboxGroup ();
      OsnovaPromena osmatrac = new OsnovaPromena();
      for (int i=0; i<ozn.length; i++) {
         Checkbox radio = new Checkbox (ozn[i]);
         radio.setCheckboxGroup (grupa);
         ploca.add (radio);
         radio.addItemListener (osmatrac);
         if (i==2) radio.setState (true);
      }
    }

    /* Okviri za tekst za registre */ {
      Panel ploca = new Panel();
      ploca.setLayout (new GridLayout (2, 1));
      add (ploca,  BorderLayout.NORTH);
      Color[] podloge = {Color.blue, Color.black};
      Color[] slova   = {Color.yellow, Color.white};
      for (int i=0; i<2; i++) {
        reg[i] = new Label ("0", Label.RIGHT);
        reg[i].setFont (new Font (null, Font.BOLD, 20));
        reg[i].setForeground (slova[i]);
        reg[i].setBackground (podloge[i]);
        ploca.add (reg[i]);
      }
    }
    
    /* Dugmad sa operatorima */ {
      String[] ozn = {"=", "0", "+=", "|=", "-=", "^=", 
                      "*=", "&=", "/=", "<<=", "%=", ">>="};
      Panel ploca = new Panel();
      add (ploca,  BorderLayout.EAST);
      ploca.setLayout (new GridLayout ((ozn.length+1)/2,2));
      OperatorAkcija osmatrac = new OperatorAkcija ();
      for (int i=0; i<ozn.length; i++) {
        Button dugme = new Button (ozn[i]);
        dugme.setForeground (Color.blue);
        dugme.setBackground (Color.yellow);
        dugme.addActionListener (osmatrac);
        ploca.add (dugme);
      }
    }
  } // Konstruktor
  
  public static void main (String[] varg) {
     new Kalkulator ().show (); 
  }
  
  private class ProzorDogadjaj extends WindowAdapter {
    public void windowClosing (WindowEvent d) { System.exit (0); }
  } // class ProzorDogadjaj
  
  private class CifraAkcija implements ActionListener {
    public void actionPerformed (ActionEvent d) {
      String cif = ((Button)d.getSource()).getLabel ();
      String staro = reg[Y].getText();
      reg[Y].setText ((noviBroj || staro.equals("0") ? "" : staro) + cif);
      noviBroj = false;
      try { y = Long.parseLong (reg[Y].getText(), osnova); 
      } catch (NumberFormatException g) {
        reg[Y].setText ("G R E S K A");
        noviBroj = true;
      }
    }
  } // class CifraAkcija
  
  private void prikazi () {
    reg[X].setText (Long.toString (x, osnova));
    reg[Y].setText (Long.toString (y, osnova));
  }
  
  private class OsnovaPromena implements ItemListener {
    public void itemStateChanged (ItemEvent d) {
      String ozn = ((Checkbox)(d.getSource())).getLabel();
      osnova = Integer.parseInt(ozn);
      for (int i=0; i<16; i++) cifre[i].setEnabled (i<osnova);
      prikazi();
    }
  } // class OsnovaPromena
  
  private class OperatorAkcija implements ActionListener {
    public void actionPerformed (ActionEvent d) {
      switch (((Button)d.getSource()).getLabel().charAt(0)) {
        case '=': x  = y; break;
        case '0': y  = 0; break;
        case '+': x  += y; break;
        case '-': x  -= y; break;
        case '*': x  *= y; break;
        case '/': x  /= y; break;
        case '%': x  %= y; break;
        case '|': x  |= y; break;
        case '^': x  ^= y; break;
        case '&': x  &= y; break;
        case '<': x <<= y; break;
        case '>': x >>= y; break;
      }
      prikazi();
      noviBroj = true;
    }
  } // class OperatorAkcija
} // class Kalkulator