// Vektor.java - Klasa vektora sa paralelnim izracunavanjima.

import usluge.*;

class Sabirac extends Thread {
  private double a, b, c;
  Sabirac (double aa, double bb) { a = aa; b = bb; }
  public void run () { c = a + b; }
  double rezultat () { return c; }
} // class Sabirac

class Mnozac extends Thread {
  private double a, b, c;
  Mnozac (double aa, double bb) { a = aa; b = bb; }
  public void run () { c = a * b; }
  double rezultat () { return c; }
} // class Mnozac

class GIndeks extends Greska {
  GIndeks (int ind)
    { super ("Nedozvoljeni indeks " + ind); }
} // class GIndeks

class GDuzina extends Greska {
  GDuzina (int duz1, int duz2) { 
    super ("Neusaglasene duzine " + duz1 + " i " + duz2);
  }
} // class GDuzina

class Vektor {
  private double[] niz;
  Vektor (int duz) { niz = new double [duz]; }
  void stavi (int ind, double broj) throws GIndeks {
    if (ind < 0 || ind >= niz.length) 
      throw new GIndeks (ind);
    niz[ind] = broj;
  }
  double uzmi (int ind) throws GIndeks {
    if (ind < 0 || ind >= niz.length) 
      throw new GIndeks (ind);
    return niz[ind];
  }
  public String toString () {
    String s = "(";
    for (int i=0; i<niz.length; i++)
      { s += niz[i]; if (i < niz.length - 1) s += ","; }
    return s + ")";
  }
  static Vektor zbir (Vektor v1, Vektor v2) 
    throws GDuzina {
    int n = v1.niz.length, n2 = v2.niz.length;
    if (n != n2) throw new GDuzina (n, n2);
    Sabirac[] sab = new Sabirac [n];
    for (int i=0; i<n; i++)
      (sab[i] = new Sabirac (v1.niz[i], v2.niz[i])).start ();
    Vektor v = new Vektor (n);
    for (int i=0; i<n; i++) 
      try { sab[i].join(); v.niz[i] = sab[i].rezultat (); }
        catch (InterruptedException g) {}
    return v;
  }
  static double skalpro (Vektor v1, Vektor v2) 
    throws GDuzina {
    int n = v1.niz.length, n2 = v2.niz.length;
    if (n != n2) throw new GDuzina (n, n2);
    Mnozac[] mno = new Mnozac [n];
    for (int i=0; i<n; i++)
      (mno[i] = new Mnozac (v1.niz[i], v2.niz[i])).start ();
    double s = 0;
    for (int i=0; i<n; i++) 
      try { mno[i].join(); s += mno[i].rezultat (); }
        catch (InterruptedException g) {}
    return s;
  }
  public static void main (String[] vpar) {
    while (true) {
      try {
        System.out.print ("n1? "); int n1 = Citaj.Int ();
    if (n1 < 0) break;
        System.out.print ("v1? "); Vektor v1 = new Vektor (n1);
        for (int i=0; i<n1; v1.stavi(i++,Citaj.Double()));
        System.out.print ("n2? "); int n2 = Citaj.Int ();
    if (n2 < 0) break;
        System.out.print ("v2? "); Vektor v2 = new Vektor (n2);
        for (int i=0; i<n2; v2.stavi(i++,Citaj.Double()));
        System.out.println ("Zbir: " + Vektor.zbir(v1,v2));
        System.out.println ("Skalpro: " + Vektor.skalpro(v1,v2) + "\n");
      } catch (Greska g) {
        System.out.println (g);
      }
    }
  }
} // class Vektor