// Kasa.java - Kasa samoposluge.

package samoposluga;
import usluge.Polje;
import java.awt.Color;

class Kasa extends Thread {

  private static int ukId = 0;
  private int maxNaplata, id=++ukId;
  private Samoposluga samoposl;
  private Polje polje;
  private Red red;
  private volatile boolean gotovo=false, radi=true;

  Kasa (Samoposluga samop, int maxNapl,
         Polje p, Polje pRed) {
    samoposl = samop;
    maxNaplata  = maxNapl;
    red = new Red (pRed);
    if ((polje = p) != null) {
      polje.komponenta().setForeground (Color.black);
      polje.pisi ("Kasa" + id);
    }
    start();
  }

  public void run () {
    while (! gotovo) {
      if (! radi) synchronized (this) { 
        while (! radi) 
          try { wait (); } catch (InterruptedException e) {} }
    if (gotovo) break;
      try {
        Kupac kupac = red.uzmi ();
        if (polje!=null) polje.pisi ("Kasa" + id + ": " + kupac.id());
        try { sleep ((long) (Math.random() * maxNaplata)); } 
          catch (InterruptedException e) {}
        kupac.naplaceno ();
        if (polje != null) polje.pisi ("Kasa" + id);
      } catch (InterruptedException e) {}
    }
  }

  synchronized void zatvori () {
    radi = false;
    if (polje != null) polje.komponenta().setForeground (Color.red);
  }

  synchronized void otvori () {
    if (! radi) {
      radi = true; notify ();
      if (polje != null) polje.komponenta().setForeground (Color.black);
    }
  }

  synchronized void zavrsi () {  
    gotovo = true;
    if (! radi) { radi = true; notify (); }
    interrupt ();
  }

  void staviURed (Kupac kupac) { red.stavi (kupac); }
  
  int id () { return id; }

} // class Kasa
