// Polje.java - Polje graficke povrsi za unos i prikaz podataka.

package usluge;
import java.awt.*;

public class Polje {
  private Component komp;
  private int ind;
  public Polje (Component k, int i) 
    throws GPoljeNeOdgovara {
    if (!(k instanceof Label)     && 
        !(k instanceof TextField) &&
        !(k instanceof TextArea)  &&
        !(k instanceof List)
       ) throw new GPoljeNeOdgovara(k);
    komp = k; ind = i;
  }
  public Polje (Component k) 
    throws GPoljeNeOdgovara { this (k, -1); }
  public Component komponenta () {
    return komp;
  }

  public void pisi (String tekst) {
    if      (komp instanceof Label) 
      ((Label)komp).setText(tekst);
    else if (komp instanceof TextField)
      ((TextField)komp).setText(tekst);
    else if (komp instanceof TextArea)
      ((TextArea)komp).setText(tekst);
    else if (komp instanceof List)
      ((List)komp).replaceItem(tekst, ind);
  }
  public void pisi (long broj) 
    { pisi (Long.toString (broj)); }
  public void pisi (long broj, int baza) 
    { pisi (Long.toString (broj, baza)); }
  public void pisi (double broj) 
    { pisi (Double.toString (broj)); }
  public void pisi (char znak) 
    { pisi (new Character(znak).toString()); }
  public void pisi (boolean b) 
    { pisi (new Boolean(b).toString()); }
  
  public String String () {
    if      (komp instanceof Label) 
      return ((Label)komp).getText();
    else if (komp instanceof TextField)
      return ((TextField)komp).getText();
    else if (komp instanceof TextArea)
      return ((TextArea)komp).getText();
    else if (komp instanceof List)
      return ((List)komp).getItem(ind);
    else return null;
  }
  public long Long () {
    return Long.parseLong (String ());
  }
  public long Long (int baza) {
    return Long.parseLong (String (), baza);
  }
  public double Double () {
    return Double.parseDouble (String ());
  }
  public char Char () {
    return String ().charAt (0);
  }
  public boolean Boolean () {
    return Boolean.valueOf (String ()).booleanValue ();
  }
} // class Polje